"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Actions = void 0;
class Actions {
    constructor(client) {
        this.client = client;
    }
    getAction(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.id}`,
                method: 'GET',
                params: {
                    display: parameters.display,
                    entities: parameters.entities,
                    fields: parameters.fields,
                    member: parameters.member,
                    member_fields: parameters.memberFields,
                    memberCreator: parameters.memberCreator,
                    memberCreator_fields: parameters.memberCreatorFields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getAction' });
        });
    }
    updateAction(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.id}`,
                method: 'PUT',
                params: {
                    text: parameters.text,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateAction' });
        });
    }
    deleteAction(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.id}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteAction' });
        });
    }
    getActionField(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.id}/${parameters.field}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getActionField' });
        });
    }
    getActionBoard(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.id}/board`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getActionBoard' });
        });
    }
    getActionCard(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.id}/card`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getActionCard' });
        });
    }
    getActionList(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.id}/list`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getActionList' });
        });
    }
    getActionMember(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.id}/member`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getActionMember' });
        });
    }
    getActionMemberCreator(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.id}/memberCreator`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getActionMemberCreator' });
        });
    }
    getActionOrganization(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.id}/organization`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getActionOrganization' });
        });
    }
    updateActionText(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.id}/text`,
                method: 'PUT',
                params: {
                    value: parameters.value,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateActionText' });
        });
    }
    getActionReactions(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.idAction}/reactions`,
                method: 'GET',
                params: {
                    member: parameters.member,
                    emoji: parameters.emoji,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getActionReactions' });
        });
    }
    addActionReaction(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.idAction}/reactions`,
                method: 'POST',
                data: {
                    shortName: parameters.shortName,
                    skinVariation: parameters.skinVariation,
                    native: parameters.native,
                    unified: parameters.unified,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'addActionReaction' });
        });
    }
    getActionReaction(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.idAction}/reactions/${parameters.id}`,
                method: 'GET',
                params: {
                    member: parameters.member,
                    emoji: parameters.emoji,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getActionReaction' });
        });
    }
    deleteActionReaction(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.idAction}/reactions/${parameters.id}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteActionReaction' });
        });
    }
    getActionReactionSummary(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/actions/${parameters.idAction}/reactionsSummary`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getActionReactionSummary' });
        });
    }
}
exports.Actions = Actions;
