"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Checklists = void 0;
class Checklists {
    constructor(client) {
        this.client = client;
    }
    createChecklist(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: '/checklists',
                method: 'POST',
                params: {
                    idCard: parameters.idCard,
                    name: parameters.name,
                    pos: parameters.pos,
                    idChecklistSource: parameters.idChecklistSource,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'createChecklist' });
        });
    }
    getChecklist(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/checklists/${parameters.id}`,
                method: 'GET',
                params: {
                    cards: parameters.cards,
                    checkItems: parameters.checkItems,
                    checkItem_fields: parameters.checkItemFields,
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getChecklist' });
        });
    }
    updateChecklist(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/checklists/${parameters.id}`,
                method: 'PUT',
                params: {
                    name: parameters.name,
                    pos: parameters.pos,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateChecklist' });
        });
    }
    deleteChecklist(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/checklists/${parameters.id}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteChecklist' });
        });
    }
    getChecklistField(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/checklists/${parameters.id}/${parameters.field}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getChecklistField' });
        });
    }
    updateChecklistField(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/checklists/${parameters.id}/${parameters.field}`,
                method: 'PUT',
                params: {
                    value: parameters.value,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateChecklistField' });
        });
    }
    getChecklistBoard(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/checklists/${parameters.id}/board`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getChecklistBoard' });
        });
    }
    getChecklistCards(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/checklists/${parameters.id}/cards`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getChecklistCards' });
        });
    }
    getChecklistCheckItems(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/checklists/${parameters.id}/checkItems`,
                method: 'GET',
                params: {
                    filter: parameters.filter,
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getChecklistCheckItems' });
        });
    }
    createChecklistCheckItems(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/checklists/${parameters.id}/checkItems`,
                method: 'POST',
                params: {
                    name: parameters.name,
                    pos: parameters.pos,
                    checked: parameters.checked,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'createChecklistCheckItems' });
        });
    }
    getChecklistCheckItem(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/checklists/${parameters.id}/checkItems/${parameters.idCheckItem}`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getChecklistCheckItem' });
        });
    }
    deleteChecklistCheckItem(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/checklists/${parameters.id}/checkItems/${parameters.idCheckItem}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteChecklistCheckItem' });
        });
    }
}
exports.Checklists = Checklists;
