"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomFields = void 0;
class CustomFields {
    constructor(client) {
        this.client = client;
    }
    createCustomField(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: '/customFields',
                method: 'POST',
                data: {
                    idModel: parameters === null || parameters === void 0 ? void 0 : parameters.idModel,
                    modelType: parameters === null || parameters === void 0 ? void 0 : parameters.modelType,
                    name: parameters === null || parameters === void 0 ? void 0 : parameters.name,
                    type: parameters === null || parameters === void 0 ? void 0 : parameters.type,
                    options: parameters === null || parameters === void 0 ? void 0 : parameters.options,
                    pos: parameters === null || parameters === void 0 ? void 0 : parameters.pos,
                    display_cardFront: parameters === null || parameters === void 0 ? void 0 : parameters.displayCardFront,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'createCustomField' });
        });
    }
    getCustomField(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/customFields/${parameters.id}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getCustomField' });
        });
    }
    updateCustomField(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/customFields/${parameters.id}`,
                method: 'PUT',
                data: {
                    name: parameters.name,
                    pos: parameters.pos,
                    'display/cardFront': parameters.dispalyCardFront,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateCustomField' });
        });
    }
    deleteCustomField(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/customFields/${parameters.id}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteCustomField' });
        });
    }
    getCustomFieldOptions(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/customFields/${parameters.id}/options`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getCustomFieldOptions' });
        });
    }
    addCustomFieldOption(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/customFields/${parameters.id}/options`,
                method: 'POST',
            };
            return this.client.sendRequest(config, callback, { methodName: 'addCustomFieldOption' });
        });
    }
    getCustomFieldsOption(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/customFields/${parameters.id}/options/${parameters.idCustomFieldOption}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getCustomFieldsOption' });
        });
    }
    deleteCustomFieldsOption(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/customFields/${parameters.id}/options/${parameters.idCustomFieldOption}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteCustomFieldsOption' });
        });
    }
}
exports.CustomFields = CustomFields;
