"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Labels = void 0;
class Labels {
    constructor(client) {
        this.client = client;
    }
    getLabel(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/labels/${parameters.id}`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getLabel' });
        });
    }
    updateLabel(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/labels/${parameters.id}`,
                method: 'PUT',
                params: {
                    name: parameters.name,
                    color: parameters.color,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateLabel' });
        });
    }
    deleteLabel(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/labels/${parameters.id}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteLabel' });
        });
    }
    updateLabelField(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/labels/${parameters.id}/${parameters.field}`,
                method: 'PUT',
                params: {
                    value: parameters.value,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateLabelField' });
        });
    }
    createLabel(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: '/labels',
                method: 'POST',
                params: {
                    name: parameters.name,
                    color: parameters.color,
                    idBoard: parameters.idBoard,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'createLabel' });
        });
    }
}
exports.Labels = Labels;
