import * as Parameters from './parameters';
import { Client } from '../clients';
import { Callback } from '../types';
export declare class Lists {
    private client;
    constructor(client: Client);
    /**
     * Get information about a List */
    getList<T = unknown>(parameters: Parameters.GetList, callback: Callback<T>): Promise<void>;
    /**
     * Get information about a List */
    getList<T = unknown>(parameters: Parameters.GetList, callback?: undefined): Promise<T>;
    /**
     * Update the properties of a List */
    updateList<T = unknown>(parameters: Parameters.UpdateList, callback: Callback<T>): Promise<void>;
    /**
     * Update the properties of a List */
    updateList<T = unknown>(parameters: Parameters.UpdateList, callback?: undefined): Promise<T>;
    /**
     * Create a new List on a Board */
    createList<T = unknown>(parameters: Parameters.CreateList, callback: Callback<T>): Promise<void>;
    /**
     * Create a new List on a Board */
    createList<T = unknown>(parameters: Parameters.CreateList, callback?: undefined): Promise<T>;
    /**
     * Archive all cards in a list */
    archiveAllCardsInList<T = unknown>(parameters: Parameters.ArchiveAllCardsInList, callback: Callback<T>): Promise<void>;
    /**
     * Archive all cards in a list */
    archiveAllCardsInList<T = unknown>(parameters: Parameters.ArchiveAllCardsInList, callback?: undefined): Promise<T>;
    /**
     * Move all Cards in a List */
    moveAllCardsInList<T = unknown>(parameters: Parameters.MoveAllCardsInList, callback: Callback<T>): Promise<void>;
    /**
     * Move all Cards in a List */
    moveAllCardsInList<T = unknown>(parameters: Parameters.MoveAllCardsInList, callback?: undefined): Promise<T>;
    /**
     * Archive or unarchive a list */
    setListCloseState<T = unknown>(parameters: Parameters.SetListCloseState, callback: Callback<T>): Promise<void>;
    /**
     * Archive or unarchive a list */
    setListCloseState<T = unknown>(parameters: Parameters.SetListCloseState, callback?: undefined): Promise<T>;
    /**
     * Move a List to a different Board */
    moveListToDifferentBoard<T = unknown>(parameters: Parameters.MoveListToDifferentBoard, callback: Callback<T>): Promise<void>;
    /**
     * Move a List to a different Board */
    moveListToDifferentBoard<T = unknown>(parameters: Parameters.MoveListToDifferentBoard, callback?: undefined): Promise<T>;
    /**
     * Rename a list */
    renameList<T = unknown>(parameters: Parameters.RenameList, callback: Callback<T>): Promise<void>;
    /**
     * Rename a list */
    renameList<T = unknown>(parameters: Parameters.RenameList, callback?: undefined): Promise<T>;
    /**
     * Get the Actions on a List */
    getListActions<T = unknown>(parameters: Parameters.GetListActions, callback: Callback<T>): Promise<void>;
    /**
     * Get the Actions on a List */
    getListActions<T = unknown>(parameters: Parameters.GetListActions, callback?: undefined): Promise<T>;
    /**
     * Get the board a list is on */
    getListBoard<T = unknown>(parameters: Parameters.GetListBoard, callback: Callback<T>): Promise<void>;
    /**
     * Get the board a list is on */
    getListBoard<T = unknown>(parameters: Parameters.GetListBoard, callback?: undefined): Promise<T>;
    /**
     * List the cards in a list */
    getListCards<T = unknown>(parameters: Parameters.GetListCards, callback: Callback<T>): Promise<void>;
    /**
     * List the cards in a list */
    getListCards<T = unknown>(parameters: Parameters.GetListCards, callback?: undefined): Promise<T>;
}
