"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Lists = void 0;
class Lists {
    constructor(client) {
        this.client = client;
    }
    getList(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/lists/${parameters.id}`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getList' });
        });
    }
    updateList(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/lists/${parameters.id}`,
                method: 'PUT',
                params: {
                    name: parameters.name,
                    closed: parameters.closed,
                    idBoard: parameters.idBoard,
                    pos: parameters.pos,
                    subscribed: parameters.subscribed,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateList' });
        });
    }
    createList(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: '/lists',
                method: 'POST',
                params: {
                    name: parameters.name,
                    idBoard: parameters.idBoard,
                    idListSource: parameters.idListSource,
                    pos: parameters.pos,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'createList' });
        });
    }
    archiveAllCardsInList(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/lists/${parameters.id}/archiveAllCards`,
                method: 'POST',
            };
            return this.client.sendRequest(config, callback, { methodName: 'archiveAllCardsInList' });
        });
    }
    moveAllCardsInList(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/lists/${parameters.id}/moveAllCards`,
                method: 'POST',
                params: {
                    idBoard: parameters.idBoard,
                    idList: parameters.idList,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'moveAllCardsInList' });
        });
    }
    setListCloseState(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/lists/${parameters.id}/closed`,
                method: 'PUT',
                params: {
                    value: parameters.value,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'setListCloseState' });
        });
    }
    moveListToDifferentBoard(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/lists/${parameters.id}/idBoard`,
                method: 'PUT',
                params: {
                    value: parameters.value,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'moveListToDifferentBoard' });
        });
    }
    renameList(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/lists/${parameters.id}/${parameters.field}`,
                method: 'PUT',
                params: {
                    value: parameters.value,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'renameList' });
        });
    }
    getListActions(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/lists/${parameters.id}/actions`,
                method: 'GET',
                params: {
                    filter: parameters.filter,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getListActions' });
        });
    }
    getListBoard(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/lists/${parameters.id}/board`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getListBoard' });
        });
    }
    getListCards(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/lists/${parameters.id}/cards`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getListCards' });
        });
    }
}
exports.Lists = Lists;
