"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Members = void 0;
class Members {
    constructor(client) {
        this.client = client;
    }
    getMember(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}`,
                method: 'GET',
                params: {
                    actions: parameters.actions,
                    boards: parameters.boards,
                    boardBackgrounds: parameters.boardBackgrounds,
                    boardsInvited: parameters.boardsInvited,
                    boardsInvited_fields: parameters.boardsInvitedFields,
                    boardStars: parameters.boardStars,
                    cards: parameters.cards,
                    customBoardBackgrounds: parameters.customBoardBackgrounds,
                    customEmoji: parameters.customEmoji,
                    customStickers: parameters.customStickers,
                    fields: parameters.fields,
                    notifications: parameters.notifications,
                    organizations: parameters.organizations,
                    organization_fields: parameters.organizationFields,
                    organization_paid_account: parameters.organizationPaidAccount,
                    organizationsInvited: parameters.organizationsInvited,
                    organizationsInvited_fields: parameters.organizationsInvitedFields,
                    paid_account: parameters.paidAccount,
                    savedSearches: parameters.savedSearches,
                    tokens: parameters.tokens,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMember' });
        });
    }
    updateMember(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}`,
                method: 'PUT',
                params: {
                    fullName: parameters.fullName,
                    initials: parameters.initials,
                    username: parameters.username,
                    bio: parameters.bio,
                    avatarSource: parameters.avatarSource,
                    'prefs/colorBlind': parameters.colorBlind,
                    'prefs/locale': parameters.locale,
                    'prefs/minutesBetweenSummaries': parameters.minutesBetweenSummaries,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateMember' });
        });
    }
    getMemberField(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/${parameters.field}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberField' });
        });
    }
    getMemberActions(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/actions`,
                method: 'GET',
                params: {
                    filter: parameters.filter,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberActions' });
        });
    }
    getMemberBoardBackgrounds(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boardBackgrounds`,
                method: 'GET',
                params: {
                    filter: parameters.filter,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberBoardBackgrounds' });
        });
    }
    uploadMemberBoardBackground(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boardBackgrounds`,
                method: 'POST',
                params: {
                    file: parameters.file,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'uploadMemberBoardBackground' });
        });
    }
    getMemberBoardBackground(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boardBackgrounds/${parameters.idBackground}`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberBoardBackground' });
        });
    }
    updateBoardBackground(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boardBackgrounds/${parameters.idBackground}`,
                method: 'PUT',
                params: {
                    brightness: parameters.brightness,
                    tile: parameters.tile,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateBoardBackground' });
        });
    }
    deleteMemberBoardBackground(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boardBackgrounds/${parameters.idBackground}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteMemberBoardBackground' });
        });
    }
    getMemberBoardStars(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boardStars`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberBoardStars' });
        });
    }
    starMemberBoard(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boardStars`,
                method: 'POST',
                params: {
                    idBoard: parameters.idBoard,
                    pos: parameters.pos,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'starMemberBoard' });
        });
    }
    getMemberBoardStar(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boardStars/${parameters.idStar}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberBoardStar' });
        });
    }
    updateMemberBoardStar(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boardStars/${parameters.idStar}`,
                method: 'PUT',
                params: {
                    pos: parameters.pos,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateMemberBoardStar' });
        });
    }
    unstarMemberBoard(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boardStars/${parameters.idStar}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'unstarMemberBoard' });
        });
    }
    getMemberBoards(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boards`,
                method: 'GET',
                params: {
                    filter: parameters.filter,
                    fields: parameters.fields,
                    lists: parameters.lists,
                    organization: parameters.organization,
                    organization_fields: parameters.organizationFields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberBoards' });
        });
    }
    getMemberBoardsInvited(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/boardsInvited`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberBoardsInvited' });
        });
    }
    getMemberCards(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/cards`,
                method: 'GET',
                params: {
                    filter: parameters.filter,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberCards' });
        });
    }
    getMemberCustomBoardBackgrounds(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customBoardBackgrounds`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberCustomBoardBackgrounds' });
        });
    }
    uploadMemberCustomBoardBackground(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customBoardBackgrounds`,
                method: 'POST',
                params: {
                    file: parameters.file,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'uploadMemberCustomBoardBackground' });
        });
    }
    getMemberCustomBoardBackground(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customBoardBackgrounds/${parameters.idBackground}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberCustomBoardBackground' });
        });
    }
    updateMemberCustomBoardBackground(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customBoardBackgrounds/${parameters.idBackground}`,
                method: 'PUT',
                params: {
                    brightness: parameters.brightness,
                    tile: parameters.tile,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateMemberCustomBoardBackground' });
        });
    }
    deleteMemberCustomBoardBackground(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customBoardBackgrounds/${parameters.idBackground}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteMemberCustomBoardBackground' });
        });
    }
    getMemberCustomEmojis(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customEmoji`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberCustomEmojis' });
        });
    }
    createMemberCustomEmoji(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customEmoji`,
                method: 'POST',
                params: {
                    file: parameters.file,
                    name: parameters.name,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'createMemberCustomEmoji' });
        });
    }
    getMemberCustomEmoji(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customEmoji/${parameters.idEmoji}`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberCustomEmoji' });
        });
    }
    getMemberCustomStickers(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customStickers`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberCustomStickers' });
        });
    }
    uploadMemberCustomSticker(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customStickers`,
                method: 'POST',
                params: {
                    file: parameters.file,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'uploadMemberCustomSticker' });
        });
    }
    getMemberCustomSticker(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customStickers/${parameters.idSticker}`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberCustomSticker' });
        });
    }
    deleteMemberCustomSticker(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/customStickers/${parameters.idSticker}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteMemberCustomSticker' });
        });
    }
    getMemberNotifications(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/notifications`,
                method: 'GET',
                params: {
                    entities: parameters.entities,
                    display: parameters.display,
                    filter: parameters.filter,
                    read_filter: parameters.readFilter,
                    fields: parameters.fields,
                    limit: parameters.limit,
                    page: parameters.page,
                    before: parameters.before,
                    since: parameters.since,
                    memberCreator: parameters.memberCreator,
                    memberCreator_fields: parameters.memberCreatorFields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberNotifications' });
        });
    }
    getMemberOrganizations(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/organizations`,
                method: 'GET',
                params: {
                    filter: parameters.filter,
                    fields: parameters.fields,
                    paid_account: parameters.paidAccount,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberOrganizations' });
        });
    }
    getMemberOrganizationsInvited(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/organizationsInvited`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberOrganizationsInvited' });
        });
    }
    getMemberSavedSearches(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/savedSearches`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberSavedSearches' });
        });
    }
    createMemberSavedSearch(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/savedSearches`,
                method: 'POST',
                params: {
                    name: parameters.name,
                    query: parameters.query,
                    pos: parameters.pos,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'createMemberSavedSearch' });
        });
    }
    getMemberSavedSearch(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/savedSearches/${parameters.idSearch}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberSavedSearch' });
        });
    }
    updateMemberSavedSearch(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/savedSearches/${parameters.idSearch}`,
                method: 'PUT',
                params: {
                    name: parameters.name,
                    query: parameters.query,
                    pos: parameters.pos,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateMemberSavedSearch' });
        });
    }
    deleteMemberSavedSearch(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/savedSearches/${parameters.idSearch}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteMemberSavedSearch' });
        });
    }
    getMemberTokens(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/tokens`,
                method: 'GET',
                params: {
                    webhooks: parameters.webhooks,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getMemberTokens' });
        });
    }
    createMemberAvatar(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/avatar`,
                method: 'POST',
                params: {
                    file: parameters.file,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'createMemberAvatar' });
        });
    }
    dismissMemberMessage(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/members/${parameters.id}/oneTimeMessagesDismissed`,
                method: 'POST',
                params: {
                    value: parameters.value,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'dismissMemberMessage' });
        });
    }
}
exports.Members = Members;
