"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Notifications = void 0;
class Notifications {
    constructor(client) {
        this.client = client;
    }
    getNotification(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/notifications/${parameters.id}`,
                method: 'GET',
                params: {
                    board: parameters.board,
                    board_fields: parameters.boardFields,
                    card: parameters.card,
                    card_fields: parameters.cardFields,
                    display: parameters.display,
                    entities: parameters.entities,
                    fields: parameters.fields,
                    list: parameters.list,
                    member: parameters.member,
                    member_fields: parameters.memberFields,
                    memberCreator: parameters.memberCreator,
                    memberCreator_fields: parameters.memberCreatorFields,
                    organization: parameters.organization,
                    organization_fields: parameters.organizationFields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getNotification' });
        });
    }
    updateNotification(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/notifications/${parameters.id}`,
                method: 'PUT',
                params: {
                    unread: parameters.unread,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateNotification' });
        });
    }
    getNotificationField(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/notifications/${parameters.id}/${parameters.field}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getNotificationField' });
        });
    }
    markAllNotificationsAsRead(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: '/notifications/all/read',
                method: 'POST',
                params: {
                    read: parameters === null || parameters === void 0 ? void 0 : parameters.read,
                    ids: parameters === null || parameters === void 0 ? void 0 : parameters.ids,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'markAllNotificationsAsRead' });
        });
    }
    updateNotificationReadStatus(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/notifications/${parameters.id}/unread`,
                method: 'PUT',
                params: {
                    value: parameters.value,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateNotificationReadStatus' });
        });
    }
    getNotificationBoard(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/notifications/${parameters.id}/board`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getNotificationBoard' });
        });
    }
    getNotificationCard(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/notifications/${parameters.id}/card`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getNotificationCard' });
        });
    }
    getNotificationList(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/notifications/${parameters.id}/list`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getNotificationList' });
        });
    }
    getNotificationMember(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/notifications/${parameters.id}/member`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getNotificationMember' });
        });
    }
    getNotificationMemberCreator(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/notifications/${parameters.id}/memberCreator`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getNotificationMemberCreator' });
        });
    }
    getNotificationOrganization(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/notifications/${parameters.id}/organization`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getNotificationOrganization' });
        });
    }
}
exports.Notifications = Notifications;
