import * as Models from './models';
import * as Parameters from './parameters';
import { Client } from '../clients';
import { Callback } from '../types';
export declare class Organizations {
    private client;
    constructor(client: Client);
    /**
     * Create a new team */
    createOrganization<T = unknown>(parameters: Parameters.CreateOrganization, callback: Callback<T>): Promise<void>;
    /**
     * Create a new team */
    createOrganization<T = unknown>(parameters: Parameters.CreateOrganization, callback?: undefined): Promise<T>;
    getOrganization<T = Models.Organization>(parameters: Parameters.GetOrganization, callback: Callback<T>): Promise<void>;
    getOrganization<T = Models.Organization>(parameters: Parameters.GetOrganization, callback?: undefined): Promise<T>;
    /**
     * Update an organization */
    updateOrganization<T = Models.Organization>(parameters: Parameters.UpdateOrganization, callback: Callback<T>): Promise<void>;
    /**
     * Update an organization */
    updateOrganization<T = Models.Organization>(parameters: Parameters.UpdateOrganization, callback?: undefined): Promise<T>;
    /**
     * Delete an Organization */
    deleteOrganization<T = unknown>(parameters: Parameters.DeleteOrganization, callback: Callback<T>): Promise<void>;
    /**
     * Delete an Organization */
    deleteOrganization<T = unknown>(parameters: Parameters.DeleteOrganization, callback?: undefined): Promise<T>;
    getOrganizationField<T = Models.Organization>(parameters: Parameters.GetOrganizationField, callback: Callback<T>): Promise<void>;
    getOrganizationField<T = Models.Organization>(parameters: Parameters.GetOrganizationField, callback?: undefined): Promise<T>;
    /**
     * List the actions on a team */
    getOrganizationActions<T = unknown>(parameters: Parameters.GetOrganizationActions, callback: Callback<T>): Promise<void>;
    /**
     * List the actions on a team */
    getOrganizationActions<T = unknown>(parameters: Parameters.GetOrganizationActions, callback?: undefined): Promise<T>;
    /**
     * List the boards in a team */
    getOrganizationBoards<T = unknown>(parameters: Parameters.GetOrganizationBoards, callback: Callback<T>): Promise<void>;
    /**
     * List the boards in a team */
    getOrganizationBoards<T = unknown>(parameters: Parameters.GetOrganizationBoards, callback?: undefined): Promise<T>;
    /**
     * Retrieve the exports that exist for the given organization */
    getOrganizationExports<T = unknown>(parameters: Parameters.GetOrganizationExports, callback: Callback<T>): Promise<void>;
    /**
     * Retrieve the exports that exist for the given organization */
    getOrganizationExports<T = unknown>(parameters: Parameters.GetOrganizationExports, callback?: undefined): Promise<T>;
    /**
     * Kick off CSV export for an organization */
    exportOrganizationCSV<T = Models.Export>(parameters: Parameters.ExportOrganizationCSV, callback: Callback<T>): Promise<void>;
    /**
     * Kick off CSV export for an organization */
    exportOrganizationCSV<T = Models.Export>(parameters: Parameters.ExportOrganizationCSV, callback?: undefined): Promise<T>;
    /**
     * List the members in a team */
    getOrganizationMembers<T = unknown>(parameters: Parameters.GetOrganizationMembers, callback: Callback<T>): Promise<void>;
    /**
     * List the members in a team */
    getOrganizationMembers<T = unknown>(parameters: Parameters.GetOrganizationMembers, callback?: undefined): Promise<T>;
    updateOrganizationMember<T = unknown>(parameters: Parameters.UpdateOrganizationMember, callback: Callback<T>): Promise<void>;
    updateOrganizationMember<T = unknown>(parameters: Parameters.UpdateOrganizationMember, callback?: undefined): Promise<T>;
    /**
     * List the memberships of a team */
    getOrganizationMemberships<T = unknown>(parameters: Parameters.GetOrganizationMemberships, callback: Callback<T>): Promise<void>;
    /**
     * List the memberships of a team */
    getOrganizationMemberships<T = unknown>(parameters: Parameters.GetOrganizationMemberships, callback?: undefined): Promise<T>;
    /**
     * Get a single Membership for an Organization */
    getOrganizationMembership<T = unknown>(parameters: Parameters.GetOrganizationMembership, callback: Callback<T>): Promise<void>;
    /**
     * Get a single Membership for an Organization */
    getOrganizationMembership<T = unknown>(parameters: Parameters.GetOrganizationMembership, callback?: undefined): Promise<T>;
    /**
     * Get organization scoped pluginData on this team */
    getOrganizationPluginData<T = unknown>(parameters: Parameters.GetOrganizationPluginData, callback: Callback<T>): Promise<void>;
    /**
     * Get organization scoped pluginData on this team */
    getOrganizationPluginData<T = unknown>(parameters: Parameters.GetOrganizationPluginData, callback?: undefined): Promise<T>;
    /**
     * List the organization's collections */
    getOrganizationTags<T = unknown>(parameters: Parameters.GetOrganizationTags, callback: Callback<T>): Promise<void>;
    /**
     * List the organization's collections */
    getOrganizationTags<T = unknown>(parameters: Parameters.GetOrganizationTags, callback?: undefined): Promise<T>;
    /**
     * Create a Tag in an Organization */
    createOrganizationTag<T = unknown>(parameters: Parameters.CreateOrganizationTag, callback: Callback<T>): Promise<void>;
    /**
     * Create a Tag in an Organization */
    createOrganizationTag<T = unknown>(parameters: Parameters.CreateOrganizationTag, callback?: undefined): Promise<T>;
    /**
     * Add a member to a team or update their member type. */
    addOrganizationMember<T = unknown>(parameters: Parameters.AddOrganizationMember, callback: Callback<T>): Promise<void>;
    /**
     * Add a member to a team or update their member type. */
    addOrganizationMember<T = unknown>(parameters: Parameters.AddOrganizationMember, callback?: undefined): Promise<T>;
    /**
     * Remove a member from a team */
    deleteOrganizationMember<T = unknown>(parameters: Parameters.DeleteOrganizationMember, callback: Callback<T>): Promise<void>;
    /**
     * Remove a member from a team */
    deleteOrganizationMember<T = unknown>(parameters: Parameters.DeleteOrganizationMember, callback?: undefined): Promise<T>;
    /**
     * Deactivate or reactivate a member of a team */
    updateOrganizationDeactivateStatus<T = unknown>(parameters: Parameters.UpdateOrganizationDeactivateStatus, callback: Callback<T>): Promise<void>;
    /**
     * Deactivate or reactivate a member of a team */
    updateOrganizationDeactivateStatus<T = unknown>(parameters: Parameters.UpdateOrganizationDeactivateStatus, callback?: undefined): Promise<T>;
    /**
     * Set the logo image for a team */
    setOrganizationLogo<T = unknown>(parameters: Parameters.SetOrganizationLogo, callback: Callback<T>): Promise<void>;
    /**
     * Set the logo image for a team */
    setOrganizationLogo<T = unknown>(parameters: Parameters.SetOrganizationLogo, callback?: undefined): Promise<T>;
    /**
     * Delete a the logo from a team */
    deleteOrganizationLogo<T = unknown>(parameters: Parameters.DeleteOrganizationLogo, callback: Callback<T>): Promise<void>;
    /**
     * Delete a the logo from a team */
    deleteOrganizationLogo<T = unknown>(parameters: Parameters.DeleteOrganizationLogo, callback?: undefined): Promise<T>;
    /**
     * Remove a member from a team and from all team boards */
    deleteOrganizationMemberFromAll<T = unknown>(parameters: Parameters.DeleteOrganizationMemberFromAll, callback: Callback<T>): Promise<void>;
    /**
     * Remove a member from a team and from all team boards */
    deleteOrganizationMemberFromAll<T = unknown>(parameters: Parameters.DeleteOrganizationMemberFromAll, callback?: undefined): Promise<T>;
    /**
     * Remove the associated Google Apps domain from a team */
    deleteOrganizationAssociatedDomain<T = unknown>(parameters: Parameters.DeleteOrganizationAssociatedDomain, callback: Callback<T>): Promise<void>;
    /**
     * Remove the associated Google Apps domain from a team */
    deleteOrganizationAssociatedDomain<T = unknown>(parameters: Parameters.DeleteOrganizationAssociatedDomain, callback?: undefined): Promise<T>;
    /**
     * Remove the email domain restriction on who can be invited to the team */
    deleteOrganizationInvites<T = unknown>(parameters: Parameters.DeleteOrganizationInvites, callback: Callback<T>): Promise<void>;
    /**
     * Remove the email domain restriction on who can be invited to the team */
    deleteOrganizationInvites<T = unknown>(parameters: Parameters.DeleteOrganizationInvites, callback?: undefined): Promise<T>;
    /**
     * Delete an organization's tag */
    deleteOrganizationTag<T = unknown>(parameters: Parameters.DeleteOrganizationTag, callback: Callback<T>): Promise<void>;
    /**
     * Delete an organization's tag */
    deleteOrganizationTag<T = unknown>(parameters: Parameters.DeleteOrganizationTag, callback?: undefined): Promise<T>;
    /**
     * Used to check whether the given board has new billable guests on it. */
    getOrganizationNewBillableGuestBoard<T = unknown>(parameters: Parameters.GetOrganizationNewBillableGuestBoard, callback: Callback<T>): Promise<void>;
    /**
     * Used to check whether the given board has new billable guests on it. */
    getOrganizationNewBillableGuestBoard<T = unknown>(parameters: Parameters.GetOrganizationNewBillableGuestBoard, callback?: undefined): Promise<T>;
}
