"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Plugins = void 0;
class Plugins {
    constructor(client) {
        this.client = client;
    }
    getPlugin(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/plugins/${parameters.id}/`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getPlugin' });
        });
    }
    updatePlugin(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/plugins/${parameters.id}/`,
                method: 'PUT',
            };
            return this.client.sendRequest(config, callback, { methodName: 'updatePlugin' });
        });
    }
    createPluginListing(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/plugins/${parameters.idPlugin}/listing`,
                method: 'POST',
                data: {
                    description: parameters.description,
                    locale: parameters.locale,
                    overview: parameters.overview,
                    name: parameters.name,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'createPluginListing' });
        });
    }
    getPluginComplianceMemberPrivacy(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/plugins/${parameters.id}/compliance/memberPrivacy`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getPluginComplianceMemberPrivacy' });
        });
    }
    updatePluginListing(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/plugins/${parameters.idPlugin}/listings/${parameters.idListing}`,
                method: 'PUT',
                data: {
                    description: parameters.description,
                    locale: parameters.locale,
                    overview: parameters.overview,
                    name: parameters.name,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updatePluginListing' });
        });
    }
}
exports.Plugins = Plugins;
