"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Search = void 0;
class Search {
    constructor(client) {
        this.client = client;
    }
    getSearch(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: '/search',
                method: 'GET',
                params: {
                    query: parameters.query,
                    idBoards: parameters.idBoards,
                    idOrganizations: parameters.idOrganizations,
                    idCards: parameters.idCards,
                    modelTypes: parameters.modelTypes,
                    board_fields: parameters.boardFields,
                    boards_limit: parameters.boardsLimit,
                    card_fields: parameters.cardFields,
                    cards_limit: parameters.cardsLimit,
                    cards_page: parameters.cardsPage,
                    card_board: parameters.cardBoard,
                    card_list: parameters.cardList,
                    card_members: parameters.cardMembers,
                    card_stickers: parameters.cardStickers,
                    card_attachments: parameters.cardAttachments,
                    organization_fields: parameters.organizationFields,
                    organizations_limit: parameters.organizationsLimit,
                    member_fields: parameters.memberFields,
                    members_limit: parameters.membersLimit,
                    partial: parameters.partial,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getSearch' });
        });
    }
    getSearchMembers(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: '/search/members/',
                method: 'GET',
                params: {
                    query: parameters.query,
                    limit: parameters.limit,
                    idBoard: parameters.idBoard,
                    idOrganization: parameters.idOrganization,
                    onlyOrgMembers: parameters.onlyOrgMembers,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getSearchMembers' });
        });
    }
}
exports.Search = Search;
