"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tokens = void 0;
class Tokens {
    constructor(client) {
        this.client = client;
    }
    getToken(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/tokens/${parameters.token}`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                    webhooks: parameters.webhooks,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getToken' });
        });
    }
    getTokenMember(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/tokens/${parameters.token}/member`,
                method: 'GET',
                params: {
                    fields: parameters.fields,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'getTokenMember' });
        });
    }
    getTokenWebhooks(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/tokens/${parameters.token}/webhooks`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getTokenWebhooks' });
        });
    }
    createTokenWebhooks(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/tokens/${parameters.token}/webhooks`,
                method: 'POST',
                params: {
                    description: parameters.description,
                    callbackURL: parameters.callbackURL,
                    idModel: parameters.idModel,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'createTokenWebhooks' });
        });
    }
    getTokenWebhook(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/tokens/${parameters.token}/webhooks/${parameters.idWebhook}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getTokenWebhook' });
        });
    }
    updateTokenWebhook(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/tokens/${parameters.token}/webhooks/${parameters.idWebhook}`,
                method: 'PUT',
                params: {
                    description: parameters.description,
                    callbackURL: parameters.callbackURL,
                    idModel: parameters.idModel,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateTokenWebhook' });
        });
    }
    deleteTokenWebhook(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/tokens/${parameters.token}/webhooks/${parameters.idWebhook}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteTokenWebhook' });
        });
    }
    deleteToken(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/tokens/${parameters.token}/`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteToken' });
        });
    }
}
exports.Tokens = Tokens;
