"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Webhooks = void 0;
class Webhooks {
    constructor(client) {
        this.client = client;
    }
    createWebhook(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: '/webhooks/',
                method: 'POST',
                params: {
                    description: parameters.description,
                    callbackURL: parameters.callbackURL,
                    idModel: parameters.idModel,
                    active: parameters.active,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'createWebhook' });
        });
    }
    getWebhook(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/webhooks/${parameters.id}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getWebhook' });
        });
    }
    updateWebhook(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/webhooks/${parameters.id}`,
                method: 'PUT',
                params: {
                    description: parameters.description,
                    callbackURL: parameters.callbackURL,
                    idModel: parameters.idModel,
                    active: parameters.active,
                },
            };
            return this.client.sendRequest(config, callback, { methodName: 'updateWebhook' });
        });
    }
    deleteWebhook(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/webhooks/${parameters.id}`,
                method: 'DELETE',
            };
            return this.client.sendRequest(config, callback, { methodName: 'deleteWebhook' });
        });
    }
    getWebhookField(parameters, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = {
                url: `/webhooks/${parameters.id}/${parameters.field}`,
                method: 'GET',
            };
            return this.client.sendRequest(config, callback, { methodName: 'getWebhookField' });
        });
    }
}
exports.Webhooks = Webhooks;
