import { Telemetry } from 'telemetry.trello.js';
import { Client } from './client';
import { Callback, RequestConfig } from '../types';
import { Config } from '../config';
export declare class BaseClient implements Client {
    private config;
    private instance;
    private telemetryClient;
    constructor(config: Config);
    protected paramSerializer(parameters: Record<string, any>): string;
    protected encode(value: string): string;
    sendRequest<T>(requestConfig: RequestConfig, callback?: Callback<T> | undefined, telemetryData?: Partial<Telemetry>): Promise<T>;
    sendRequest<T>(requestConfig: RequestConfig, callback: Callback<T>, telemetryData?: Partial<Telemetry>): Promise<void>;
}
