import { AxiosError, AxiosRequestConfig } from 'axios';
import { TelemetryConfig } from 'telemetry.trello.js';
export interface Config {
    key: string;
    token: string;
    baseRequestConfig?: Config.BaseRequestConfig;
    middlewares?: Config.Middlewares;
    telemetry?: Config.Telemetry;
}
export declare namespace Config {
    type Error = AxiosError;
    type BaseRequestConfig = AxiosRequestConfig;
    type Telemetry = boolean | TelemetryConfig;
    interface Middlewares {
        onError?: Config.Middlewares.OnErrorHandler;
        onResponse?: Config.Middlewares.OnResponseHandler;
    }
    namespace Middlewares {
        type OnErrorHandler = (error: Config.Error) => void;
        type OnResponseHandler<T = unknown> = (data: T) => void;
    }
}
